#include "utils.h"

#define DUTYCYCLE_MAX 280

#define KP			400000
#define KI			100000
#define FACTOR	1000000

#define ADCREF 380

typedef signed long pidDataType;

pidDataType errTotal = 0;
pidDataType err;
pidDataType tempDuty;
pidDataType delta;

void PID(s16 feedBack, s16 setValue, u16* dutyCycle){
	err = setValue - feedBack;
	tempDuty = *dutyCycle;
	delta = KP*err + KI*errTotal;
	
	delta = delta / FACTOR;
	tempDuty += delta;
	errTotal = err;

	
	if (tempDuty > DUTYCYCLE_MAX)	
		tempDuty = DUTYCYCLE_MAX;
	if (tempDuty < 0)
		tempDuty = 0;
	
	*dutyCycle = (u16)tempDuty;
}

void attemptPID(s16 feedBack, s16 setValue, u16* dutyCycle){
	if (feedBack > setValue){
		if (feedBack - setValue > 5)
			PID(feedBack, setValue, dutyCycle);
	}else{
		if (setValue - feedBack > 5)
			PID(feedBack, setValue, dutyCycle);
	}
}