#include "utils.h"
#include "PID.h"

#define DUTYCYCLE_RESOLUTION 320

u16 dutyCycle = 1;
u8 i;

void sendString(const char* str){
	while (*str){
		UART1_SendData8(*str);
		while(RESET ==UART1_GetFlagStatus(UART1_FLAG_TXE));
		str++;
	}
}




void TIM4_IRQ(void){
	TIM4_ClearITPendingBit(TIM4_IT_UPDATE);

	PID(ADC_Perform(4),2*ADC_Perform(3),&dutyCycle);
	TIM1_SetCompare1(dutyCycle);
}

void main(void){
	i=0;
	Init();
		
	TIM1_TimeBaseInit(0, TIM1_COUNTERMODE_UP, DUTYCYCLE_RESOLUTION, 0);
	TIM1_OC1Init (TIM1_OCMODE_PWM1,
								TIM1_OUTPUTSTATE_ENABLE, 
								TIM1_OUTPUTNSTATE_ENABLE,
								0,
								TIM1_OCPOLARITY_HIGH,
								TIM1_OCPOLARITY_HIGH,
								TIM1_OCIDLESTATE_RESET,
								TIM1_OCIDLESTATE_RESET);
	TIM1_CtrlPWMOutputs(ENABLE);
	TIM1_Cmd(ENABLE);
	
	TIM1_SetCompare1(1);
	
	TIM4_TimeBaseInit(TIM4_PRESCALER_64, 0xFF);
	TIM4_SetCounter(0xFF);
	TIM4_ITConfig(TIM4_IT_UPDATE, ENABLE);
	rim();
	TIM4_Cmd(ENABLE);
	
	LED_On();

  while (1){
		//UART1_Puts("ΰ\n");
		//UART1_Send_Inf("Err:",err);
		//UART1_Send_Inf("Err total:",errTotal);
		//UART1_Send_Inf("Delta:",delta);
		UART1_Send_Inf("DT:",dutyCycle*100/DUTYCYCLE_RESOLUTION);
		//sendU16(ADC_Perform(4));
  }
}



#ifdef USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param file: pointer to the source file name
  * @param line: assert_param error line source number
  * @retval : None
  */
void assert_failed(u8* file, u32 line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
		UART1_Send_Inf("Err total:",errTotal);
  }
}
#endif

/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/
